=== debian/changelog ===
plplot (5.13.0+dfsg-6ubuntu2) bionic; urgency=high

  * No change rebuild.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 02 Nov 2017 05:12:17 +0000

plplot (5.13.0+dfsg-6ubuntu1) bionic; urgency=high

  * Build with -O2, to avoid segfault on ppc64el.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 01 Nov 2017 12:58:29 +0000

plplot (5.13.0+dfsg-6) unstable; urgency=medium

  * Convert remaining symlinks (Closes: #875911)
  * Push Standards-Version to 4.1.1. No changes required.

 -- Ole Streicher <olebole@debian.org>  Thu, 05 Oct 2017 11:32:13 +0200

plplot (5.13.0+dfsg-5) unstable; urgency=medium

  * Convert old symlink to directory in libplplot-dev

 -- Ole Streicher <olebole@debian.org>  Tue, 26 Sep 2017 09:33:42 +0200

plplot (5.13.0+dfsg-4) unstable; urgency=medium

  * Install all packages for CI test (still fails, however)
  * Fix version number in maintscript.
  * Move plserver program to plplot-tcl-bin package and /usr/bin

 -- Ole Streicher <olebole@debian.org>  Mon, 25 Sep 2017 16:00:32 +0200

plplot (5.13.0+dfsg-3) unstable; urgency=medium

  * Add CMake plplot config files to libplplot-dev
  * Disable ocaml tests on MIPS completely

 -- Ole Streicher <olebole@debian.org>  Sun, 24 Sep 2017 11:13:40 +0200

plplot (5.13.0+dfsg-2) unstable; urgency=medium

  * Adjust Multi-Arch according to hinter
  * Fix symlink->directory change command in installer scripts
  * Fix ocaml dependencies
  * Completely disable x22ocaml test. (Closes: #876485)
  * Fix python libraries for different python versions

 -- Ole Streicher <olebole@debian.org>  Sat, 23 Sep 2017 15:30:28 +0200

plplot (5.13.0+dfsg-1) unstable; urgency=low

  * Finally make all occaml test failures non-fatal
  * Switch back to unstable

 -- Ole Streicher <olebole@debian.org>  Fri, 22 Sep 2017 08:45:48 +0200

plplot (5.13.0+dfsg-1~exp3) experimental; urgency=low

  * Disable more failing ocaml tests: x16ocaml, x22ocaml

 -- Ole Streicher <olebole@debian.org>  Thu, 21 Sep 2017 17:27:52 +0200

plplot (5.13.0+dfsg-1~exp2) experimental; urgency=low

  * Fix CI test subdir name
  * Merge patches from Ubuntu
  * Convert symlinks from old packages to directories on upgrade
    (Closes: #875913)
  * Disable failing test x09ocaml

 -- Ole Streicher <olebole@debian.org>  Wed, 20 Sep 2017 09:26:16 +0200

plplot (5.13.0+dfsg-1~exp1) experimental; urgency=medium

  * New maintainer and debian-science team maintenance. Closes: #867049
  * Convert repository to git
  * Push Standards-Version to 4.1.0
  * Update maintainer and URLs in d/control and d/copyright
  * New upstream version 5.13.0+dfsg. Closes: #873998, #807016
  * Switch to experimental. Prepare transition for new SONAMEs
  * New/re-enabled bindings: ocaml, ada, python3, python3-qt, octave
  * Disable OCaml Cairo bindings (not built upstream by default)
  * Split CSIRO package in to nn and csiro packages
  * Update license of csiro and nn libraries. Closes: #500687
  * Use Qt5 instead of Qt4. Closes: #875101
  * Separate wxwindows and Qt driver from bindings
  * Reformat patches for gbp
  * Simplify debian files. Revert preprocessing for d/control.in
  * Fix dependencies. Closes: #787818
  * Remove Multi-Arch from plplot-tcl. Closes: #762736
  * Install unprocessed examples. Closes: #762735, #762737
  * Add build time tests
  * Initial d/u/metadata
  * Added Build-bindings-for-all-Python-versions.patch

 -- Ole Streicher <olebole@debian.org>  Fri, 08 Sep 2017 22:00:33 +0200
