=== debian/tests/control ===
Tests: plplot-test
Depends: @, cmake, gcc, bash
Restrictions: allow-stderr
