=== debian/watch ===
version=3
opts="uversionmangle=s/-/~/,dversionmangle=s/\+dfsg$//,repacksuffix=+dfsg" \
  http://sf.net/plplot/plplot-(.*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
